import java.io.*;

public class FileLister2
{
   private ExtensionFilter filter;

   public FileLister2(String suffix)
   {
      filter = new ExtensionFilter(suffix);
   }

   public void showMatches(File dir) throws IOException
   {
      File[] entries = dir.listFiles(filter);
      for (int i = 0; i < entries.length; i++) {
         File entry = entries[i];
         if (entry.isFile())
            System.out.println(entry.getPath());
         else
            showMatches(entry);
      }
   }

   public static void main(String[] args)
      throws IOException
   {
      File rootDir = new File(args[0]);
      String suffix = args[1];

      new FileLister2(suffix).showMatches(rootDir);
   }
}
