/** Example demonstrates the effect of passing
    an Ojbect to a method.
 */
 
 package ch36604;
 
 public class GCPassAnObject {
 
     public static void tryToChangeMe( StringBuffer buf ){
        // the original object will be changed
        buf.append(" Goodbye World!");
        System.out.println("'buf' modified by tryToChangeMe(): " + buf );
        
        // point the parameter variable at a different object
        StringBuffer sb = new StringBuffer("I'm a new String!");
        buf = sb;
        System.out.println("'buf' assigned to new object in tryToChangeMe(): " + buf );
    }
    
     public static void main(String[] args) {

        StringBuffer buf = new StringBuffer("Hello World!");
        System.out.println();
        tryToChangeMe( buf );
        System.out.println("'buf' in main() after tryToChangeMe(): " + buf );        
    }

 }