import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;

public class GreekTextDisplayer extends JPanel
{
   public GreekTextDisplayer() throws IOException
   {
      // Start with a stream of bytes

      FileInputStream stream =
         new FileInputStream("alphabet.txt");

      // Convert to characters with an InputStreamReader
      // using the appropriate encoding

      InputStreamReader reader =
         new InputStreamReader(stream, "ISO8859_7");

      // Use BufferedReader to read lines

      BufferedReader in = new BufferedReader(reader);

      // Read Greek text

      String text = in.readLine();
      in.close();

      // Create a label to display the text

      JLabel label = new JLabel("The text is " + text);
      label.setFont(new Font("Serif", Font.PLAIN, 20));
      label.setForeground(Color.black);

      add(label);
   }

   public static void main(String[] args)
      throws IOException
   {
      JFrame frame = new JFrame();
      frame.setTitle("Greek Text");
      frame.getContentPane().add
         (new GreekTextDisplayer(), BorderLayout.CENTER);
      frame.setSize(400, 80);
      frame.setVisible(true);
   }
}
