interface Edible {  }
interface EdibleByHumans extends Edible {  }

class Fruit implements EdibleByHumans{ } 
class Apple extends Fruit{  }
class Orange extends Fruit{  }

class RedApple extends Apple{  }
class FloridaOrange extends Orange{  }

public class InstanceOfDemo
{
	public static void main( String args[] )
	{
		Object obj1 = new Object() ;

		System.out.println( "null instanceof java.lang.Object : " + 
											( null instanceof Object ));

		System.out.println( "null instanceof Edible : " + 
											( null instanceof Edible ));

		// This line produces a compiler error since 'null' is not a valid type.
		// System.out.println( "Object instanceof null : " + 
		//									( obj1 instanceof null ));

		
		Fruit grapes 	= new Fruit();
		Apple apple 	= new Apple();
		Orange orange 	= new Orange() ;
				
		System.out.println( "grapes instanceof Edible : " + 
											( grapes instanceof Edible ));

		System.out.println( "grapes instanceof EdibleByHumans : " + 
											( grapes instanceof EdibleByHumans ));

		System.out.println( "grapes instanceof Fruit : " + 
											( grapes instanceof Fruit ));

		System.out.println( "grapes instanceof Apple : " + 
											( grapes instanceof Apple ));

		System.out.println( "apple instanceof Edible : " + 
											( apple  instanceof Edible ));

		System.out.println( "apple  instanceof EdibleByHumans : " + 
											( apple  instanceof EdibleByHumans ));

		System.out.println( "apple  instanceof Fruit : " + 
											( apple  instanceof Fruit ));

		// The following line can never be true and an error is flagged 
		// at the compile time!
		/* 
		System.out.println( "apple  instanceof Orange : " + 
											( apple  instanceof Orange ));
		*/

		RedApple redapple = new RedApple();
		FloridaOrange floridaOrange = new FloridaOrange();
		
		System.out.println( "redapple  instanceof Edible : " + 
											( redapple  instanceof Edible ));

		System.out.println( "redapple  instanceof Fruit : " + 
											( redapple  instanceof Fruit ));
		
		System.out.println( "redapple  instanceof Apple : " + 
											( redapple  instanceof Apple ));

		System.out.println( "floridaOrange  instanceof Orange : " + 
											( floridaOrange  instanceof Orange ));

		// Trivial check.
		System.out.println( "floridaOrange  instanceof FloridaOrange : " + 
											( floridaOrange  instanceof FloridaOrange));

		Apple BagOfApples[] = new Apple[10];
		System.out.println( "BagOfApples instanceof java.lang.Object : " + 
											( BagOfApples instanceof Object ));
		
		System.out.println( "BagOfApples instanceof java.lang.Cloneable : " + 
											( BagOfApples instanceof Cloneable ));
		
		System.out.println( "BagOfApples instanceof Edible[] : " + 
											( BagOfApples instanceof Edible[] ));
											
		System.out.println( "BagOfApples instanceof Apple[] : " + 
											( BagOfApples instanceof Apple[] ));
	}
}
