public class SyncAccountDemo  implements Runnable
{
	private Account myAccount = new Account();
	
	public static void main ( String s[] )
	{
		SyncAccountDemo a1 = new SyncAccountDemo();
		
		Thread t1 = new Thread( a1 ) ;
		Thread t2 = new Thread( a1 ) ;
		
		System.out.println( "Starting thread 1 ");
		t1.start();
		System.out.println( "Starting thread 2 ");
		t2.start();
		
	}
	
	synchronized public void run()
	{
		int beginBalance = myAccount.getBalance();
		for ( long i=0 ; i < 500000 ; i++ )
		{
			myAccount.deposit( 200 );
			myAccount.withdraw( 200 );
			if ( myAccount.getBalance() != beginBalance )
				System.out.println( "Iteration # " + i + 
									" Begin balance = " + beginBalance + 
									" End balance = " + myAccount.getBalance());
		}
	}
}