public class TestWrapperEquals {
    public static void main(String[] args){
        
        Character charA = new Character('A');
        Character charB = new Character('A');
        System.out.print("charA.equals(charB) : " + charA.equals(charB) );
        System.out.println("\tcharA == charB  : " + ( charA == charB ) );                    

        Integer intA = new Integer( 100 );
        Integer intB = new Integer( 100 );
        System.out.print("intA.equals(intB)   : " + intA.equals(intB) );
        System.out.println("\tintA == intB    : " + ( intA == intB ) );                    
        
        System.out.print("\ncharA hashcode: " + charA.hashCode() );
        System.out.println("\t\tcharB hashcode: " + charB.hashCode() );                                
        System.out.print("intA hashcode: " + intA.hashCode() );
        System.out.println("\t\tintB hashcode: " + intB.hashCode() );                                        
   }
}