import java.io.*;

public class ExtensionFilter implements FileFilter
{
   private String ext;
   public ExtensionFilter(String ext)
   {
      this.ext = ext;
   }
   public boolean accept(File path)
   {
      return
         path.isDirectory() ||
         path.getName().endsWith(ext);
   }
}
