import java.util.*;

public class ListIteratorDemo
{
   public static void main(String[] args)
   {
      List wordList = new ArrayList();
      wordList.add("Give");
      wordList.add("my");
      wordList.add("regards");
      wordList.add("to");
      wordList.add("Broadway");

      // Search backward through the list, replacing
      // every occurence of "Broadway" with the
      // two elements "King" and "Tut"

      System.out.println("Before:  " + wordList);

      ListIterator li = wordList.listIterator(wordList.size());
      while (li.hasPrevious()) {
         String word = (String) li.previous();
         System.out.println("Reading: [" + word + "]");
         if (word.equals("Broadway")) {
            li.remove();
            li.add("King");
            li.add("Tut");
         }
      }

      System.out.println("After:   " + wordList);
   }
}
