import java.io.*;

public class NameTester
{
   public static void main(String[] args)
      throws IOException
   {
      // Get a file name from the command line
      // and create a File object for it

      String fileName = args[0];
      File file = new File(fileName);

      // Display file attributes

      System.out.println("Names components of " + fileName + ":");
      System.out.println("absolute:   " + file.getAbsolutePath());
      System.out.println("canonical:  " + file.getCanonicalPath());
      System.out.println("name:       " + file.getName());
      System.out.println("parent:     " + file.getParent());
      System.out.println("path:       " + file.getPath());
      System.out.println("URL:        " + file.toURL());
   }
}
