class PriorityThread extends Thread
{
	private String myName;

	PriorityThread( String sName, int nPriority )
	{	
		myName = sName ;
		setPriority( nPriority );
	}
	
	public void run()
	{
		System.out.println( myName + " with priority " + getPriority() +  " running..." );
	}
}


public class PriorityDemo 
{
	public static void main( String s[] )
	{
		PriorityThread t1 = new PriorityThread("Thread #1", Thread.MIN_PRIORITY);
		PriorityThread t2 = new PriorityThread("Thread #2", Thread.MAX_PRIORITY);
		PriorityThread t3 = new PriorityThread("Thread #3", Thread.MAX_PRIORITY - 2 );
		PriorityThread t4 = new PriorityThread("Thread #4", Thread.NORM_PRIORITY);
	
		t1.start();
		t2.start();
		t3.start();
		t4.start();
	}
}