public class Sync2AccountDemo  implements Runnable
{
	private Account myAccount = new Account();
	
	public static void main ( String s[] )
	{
		Sync2AccountDemo a1 = new Sync2AccountDemo();
		
		Thread t1 = new Thread( a1 ) ;
		Thread t2 = new Thread( a1 ) ;
		
		System.out.println( "Starting thread 1 ");
		t1.start();
		System.out.println( "Starting thread 2 ");
		t2.start();
		
	}
	
	
	public void run()
	{
		int beginBalance = myAccount.getBalance();
		for ( long i=0 ; i < 500000 ; i++ )
		{
			synchronized( myAccount )
			{
				myAccount.deposit( 200 );
				myAccount.withdraw( 200 );
				if ( myAccount.getBalance() != beginBalance )
					System.out.println( "Iteration # " + i + 
										" Begin balance = " + beginBalance + 
										" End balance = " + myAccount.getBalance());
			}
		}
	}
}