import java.io.*;

public class OutputExample
{
   private static final String CRLF =
      System.getProperty("line.separator");

   private static final String[] lines = {
      "     Simple Gifts",
      "",
      "'Tis a gift to be simple",
      "   'Tis a gift to be free",
      "'Tis a gift to come down ",
      "   where we ought to be ",
      "And when we find ourselves ",
      "   in the place just right",
      "'Twill be in the valley",
      "   of love and delight. ",
   };

   public static void main(String[] args)
      throws IOException
   {
      OutputStream out = new FileOutputStream("simplegifts.txt");

      for (int i = 0; i < lines.length; i++) {
         byte[] text = lines[i].getBytes();
         out.write(text);
         out.write(CRLF.getBytes());
      }
      out.flush();
      out.close();
   }
}
